if (select(6, GetAddOnInfo("PitBull4_" .. (debugstack():match("[o%.][d%.][u%.]les\\(.-)\\") or ""))) ~= "MISSING") then return end

local PitBull4 = PitBull4
if not PitBull4 then
	error("PitBull4_VengeanceBar requires PitBull4")
end
local PitBull4_LuaTexts = PitBull4:GetModule("LuaTexts")

local vengeanceSpell = GetSpellInfo(93098)
local playerClass = select(2, UnitClass("player"))
local maxVengeanceAP
local tankSpecs = { WARRIOR = 3, DEATHKNIGHT = 1, DRUID = 2, PALADIN = 2 }

--tooltip scanner to get the attack power value from the vengeance buff
local GetVengeanceAP
do
	local tooltip = CreateFrame("GameTooltip", "VengeanceBarTooltip", nil, "GameTooltipTemplate")
	tooltip:SetOwner(UIParent, "ANCHOR_NONE")
	
	function GetVengeanceAP()
		if UnitBuff("player", vengeanceSpell) then
			tooltip:ClearLines()
			tooltip:SetUnitBuff("player", vengeanceSpell)
			return tonumber(string.match(VengeanceBarTooltipTextLeft2:GetText() or "", "%d+")) or 0
		end
		return 0
	end
end

local function GetVengeanceAPMax()
	return UnitHealthMax("player") * 0.1
end

--Allow for getting the AP value in LuaTexts
if PitBull4_LuaTexts then
	PitBull4_LuaTexts.ScriptEnv.VengeanceAP = GetVengeanceAP
	PitBull4_LuaTexts.ScriptEnv.VengeanceAPMax = GetVengeanceAPMax
end
--[[
Lua:Vengeance

if IsMouseOver() then
  local cur,max = VengeanceAP(),VengeanceAPMax()
  return "%d/%d (%d%%)",cur,max,Percent(cur,max)
end
return ConfigMode()
--]]

local L = {}
L["Vengeance bar"] = "Vengeance bar"
L["Show a bar indicating the attack power gained from your Vengeance."] = "Show a bar indicating the attack power gained from your Vengeance."

local PitBull4_VengeanceBar = PitBull4:NewModule("VengeanceBar", "AceEvent-3.0")

PitBull4_VengeanceBar:SetModuleType("bar")
PitBull4_VengeanceBar:SetName(L["Vengeance bar"])
PitBull4_VengeanceBar:SetDescription(L["Show a bar indicating the attack power gained from your Vengeance."])
PitBull4_VengeanceBar:SetDefaults({
	size = 1,
	position = 4,
	enabled = false,
})

function PitBull4_VengeanceBar:OnEnable()
	self:RegisterEvent("PLAYER_ENTERING_WORLD")
	self:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
	self:RegisterEvent("PLAYER_TALENT_UPDATE")
end

function PitBull4_VengeanceBar:GetValue(frame)
	if maxVengeanceAP and frame.unit == "player" then
		return GetVengeanceAP() / maxVengeanceAP
	end
end

function PitBull4_VengeanceBar:GetExampleValue()
	return 0.7
end

function PitBull4_VengeanceBar:GetColor()
	local color = PitBull4.PowerColors.POWER_TYPE_HEAT
	if color then
		return color[1], color[2], color[3]
	end
end

function PitBull4_VengeanceBar:UpdateAll()
	for frame in PitBull4:IterateFramesForUnitID("player") do
		self:Update(frame)
	end
end


function PitBull4_VengeanceBar:ACTIVE_TALENT_GROUP_CHANGED()
	self:UnregisterEvent("UNIT_MAXHEALTH")
	self:UnregisterEvent("UNIT_AURA")
	
	--check spec for vengeance
	if GetPrimaryTalentTree() == tankSpecs[playerClass] then
		self:RegisterEvent("UNIT_MAXHEALTH")
		self:RegisterEvent("UNIT_AURA")
		maxVengeanceAP = GetVengeanceAPMax()
	else
		maxVengeanceAP = nil
	end
	
	self:UpdateAll()
end
PitBull4_VengeanceBar.PLAYER_ENTERING_WORLD = PitBull4_VengeanceBar.ACTIVE_TALENT_GROUP_CHANGED
PitBull4_VengeanceBar.PLAYER_TALENT_UPDATE = PitBull4_VengeanceBar.ACTIVE_TALENT_GROUP_CHANGED

function PitBull4_VengeanceBar:UNIT_AURA(_, unit)
	if unit == "player" then
		self:UpdateAll()
	end
end

function PitBull4_VengeanceBar:UNIT_MAXHEALTH(_, unit)
	if unit == "player" then
		maxVengeanceAP = GetVengeanceAPMax()
		self:UpdateAll()
	end
end
